Imports Infragistics.Win
Imports Infragistics.Win.Misc
Imports Infragistics.Win.UltraWinGrid
Imports Infragistics.Win.UltraWinEditors

Public Class Form1

    Private Sub Form1_Shown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shown
        LoadData()
    End Sub

    Private Sub UltraButton1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles UltraButton1.Click
        LoadData()
    End Sub

    Private Sub CheckBox1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox1.CheckedChanged
        LoadData()
    End Sub

    Private Sub LoadData()
        Dim dt As DataTable = CreateSummarySP()
        Dim rnd As New Random()

        For i As Integer = 1 To 10
            Dim dr As DataRow = dt.NewRow
            dr("smid") = i
            dr("smnm") = "Person " & i

            dr("cnt_n") = rnd.Next(10, 100)
            dr("totfrgross_n") = rnd.Next(10000, 999999) / 100
            dr("avgfrgross_n") = Math.Round(CalcDivision(dr("totfrgross_n"), dr("cnt_n")), 4)

            dr("cnt_u") = rnd.Next(10, 100)
            dr("totfrgross_u") = rnd.Next(10000, 999999) / 100
            dr("avgfrgross_u") = Math.Round(CalcDivision(dr("totfrgross_u"), dr("cnt_u")), 4)

            dr("cnt") = dr("cnt_n") + dr("cnt_u")
            dr("totfrgross") = dr("totfrgross_n") + dr("totfrgross_u")
            dr("avgfrgross") = Math.Round(CalcDivision(dr("totfrgross"), dr("cnt")), 4)

            dt.Rows.Add(dr)

        Next

        Me.UltraGrid1.DataSource = dt
    End Sub

    Private Function CalcDivision(ByVal num As Double, ByVal den As Double) As Double
        If den = 0 Then Return 0
        Return num / den
    End Function

    Private Function CreateSummarySP() As DataTable
        Dim dt As New DataTable("summsp")
        dt.Columns.Add("smid", GetType(Integer))
        dt.Columns.Add("smnm", GetType(String))

        dt.Columns.Add("cnt", GetType(Integer))
        dt.Columns.Add("totfrgross", GetType(Double))
        dt.Columns.Add("avgfrgross", GetType(Double))

        dt.Columns.Add("cnt_n", GetType(Integer))
        dt.Columns.Add("totfrgross_n", GetType(Double))
        dt.Columns.Add("avgfrgross_n", GetType(Double))

        dt.Columns.Add("cnt_u", GetType(Integer))
        dt.Columns.Add("totfrgross_u", GetType(Double))
        dt.Columns.Add("avgfrgross_u", GetType(Double))

        dt.Columns("cnt").DefaultValue = 0
        dt.Columns("totfrgross").DefaultValue = 0
        dt.Columns("avgfrgross").DefaultValue = 0

        dt.Columns("cnt_n").DefaultValue = 0
        dt.Columns("totfrgross_n").DefaultValue = 0
        dt.Columns("avgfrgross_n").DefaultValue = 0

        dt.Columns("cnt_u").DefaultValue = 0
        dt.Columns("totfrgross_u").DefaultValue = 0
        dt.Columns("avgfrgross_u").DefaultValue = 0

        dt.PrimaryKey = New DataColumn() {dt.Columns("smid")}
        Return dt
    End Function

    Private Sub UltraGrid1_InitializeLayout(ByVal sender As System.Object, ByVal e As Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs) Handles UltraGrid1.InitializeLayout

        Dim band As UltraGridBand = e.Layout.Bands(0)
        Dim cols As ColumnsCollection = band.Columns
        Dim col As UltraGridColumn

        Me.GridConfigure(e)

        ' hide columns that should not be used
        For Each col In cols
            col.CellActivation = Activation.NoEdit
            col.AllowRowFiltering = DefaultableBoolean.False

            col.Header.Caption = ""
            col.Header.Appearance.TextHAlign = HAlign.Left

            Select Case col.Key.ToLower
                Case "smnm"
                    col.Header.Caption = "SP"

                Case "cnt_n"
                    col.Header.Caption = "#"
                    col.Width = 22
                    col.MinWidth = col.Width
                    col.MaxWidth = col.MaxWidth
                    col.CellAppearance.TextHAlign = HAlign.Right

                Case "totfrgross_n"
                    col.Header.Caption = "Total"
                    col.Width = 50
                    col.MinWidth = col.Width
                    col.MaxWidth = col.MaxWidth
                    col.CellAppearance.TextHAlign = HAlign.Right
                    col.Format = "#,##0.00"

                Case "avgfrgross_n"
                    col.Header.Caption = "Avg"
                    col.Width = 50
                    col.MinWidth = col.Width
                    col.MaxWidth = col.MaxWidth
                    col.CellAppearance.TextHAlign = HAlign.Right
                    col.Format = "#,##0.00"

                Case "cnt_u"
                    col.Header.Caption = "#"
                    col.Width = 22
                    col.MinWidth = col.Width
                    col.MaxWidth = col.MaxWidth
                    col.CellAppearance.TextHAlign = HAlign.Right

                Case "totfrgross_u"
                    col.Header.Caption = "Total"
                    col.Width = 50
                    col.MinWidth = col.Width
                    col.MaxWidth = col.MaxWidth
                    col.CellAppearance.TextHAlign = HAlign.Right
                    col.Format = "#,##0.00"

                Case "avgfrgross_u"
                    col.Header.Caption = "Avg"
                    col.Width = 50
                    col.MinWidth = col.Width
                    col.MaxWidth = col.MaxWidth
                    col.CellAppearance.TextHAlign = HAlign.Right
                    col.Format = "#,##0.00"

                Case Else
                    col.Hidden = True

            End Select

        Next

        '
        ' header
        '
        If Me.CheckBox1.Checked Then

            If band.Groups.Exists("hdr_n") = False Then

                'Dim ugg As UltraGridGroup

                Dim ugg1 As UltraGridGroup = band.Groups.Add("hdr_tot")
                ugg1.Header.Caption = "Total"
                ugg1.Columns.Add(band.Columns("cnt"), 0, 0)
                ugg1.Columns.Add(band.Columns("totfrgross"), 1, 0)
                ugg1.Columns.Add(band.Columns("avgfrgross"), 2, 0)

                Dim ugg2 As UltraGridGroup = band.Groups.Add("hdr_n")
                ugg2.Header.Caption = "New"
                ugg2.Columns.Add(band.Columns("cnt_n"), 0, 0)
                ugg2.Columns.Add(band.Columns("totfrgross_n"), 1, 0)
                ugg2.Columns.Add(band.Columns("avgfrgross_n"), 2, 0)

                Dim ugg3 As UltraGridGroup = band.Groups.Add("hdr_u")
                ugg3.Header.Caption = "Used"
                ugg3.Columns.Add(band.Columns("cnt_u"), 0, 0)
                ugg3.Columns.Add(band.Columns("totfrgross_u"), 1, 0)
                ugg3.Columns.Add(band.Columns("avgfrgross_u"), 2, 0)

            End If

        Else

            band.Groups.Clear()

        End If

        '
        ' sub-total
        '
        If band.Summaries.Exists("summary_totfrgross_n") = False Then
            band.Summaries.Add("summary_smnm", SummaryType.Formula, band.Columns("smnm"), SummaryPosition.UseSummaryPositionColumn)

            band.Summaries.Add("summary_cnt_n", SummaryType.Sum, band.Columns("cnt_n"), SummaryPosition.UseSummaryPositionColumn)
            band.Summaries.Add("summary_totfrgross_n", SummaryType.Sum, band.Columns("totfrgross_n"), SummaryPosition.UseSummaryPositionColumn)
            band.Summaries.Add("summary_avgfrgross_n", SummaryType.Custom, New UltraGridSummaryAverage(UltraGridSummaryAverage._CALCTYPE.FRONTGROSS_N), band.Columns("avgfrgross_n"), SummaryPosition.UseSummaryPositionColumn, Nothing)

            band.Summaries.Add("summary_cnt_u", SummaryType.Sum, band.Columns("cnt_u"), SummaryPosition.UseSummaryPositionColumn)
            band.Summaries.Add("summary_totfrgross_u", SummaryType.Sum, band.Columns("totfrgross_u"), SummaryPosition.UseSummaryPositionColumn)
            band.Summaries.Add("summary_avgfrgross_u", SummaryType.Custom, New UltraGridSummaryAverage(UltraGridSummaryAverage._CALCTYPE.FRONTGROSS_U), band.Columns("avgfrgross_u"), SummaryPosition.UseSummaryPositionColumn, Nothing)

            With e.Layout.Override
                .SummaryFooterCaptionVisible = DefaultableBoolean.False
                .SummaryFooterAppearance.BackColor = Color.White
                .SummaryValueAppearance.BackColor = Color.White
            End With

            For i As Integer = 0 To band.Summaries.Count - 1
                With band.Summaries(i)
                    .Appearance.TextHAlign = HAlign.Right
                    .Appearance.FontData.Bold = DefaultableBoolean.True
                    Select Case .Key.ToLower
                        Case "summary_cnt_n", "summary_cnt_u"
                            .DisplayFormat = "{0}"
                        Case Else
                            .DisplayFormat = "{0:#,##0.00}"
                    End Select
                End With
            Next

            band.Summaries("summary_smnm").DisplayFormat = "Total:"

        End If

        '
        ' order the columns
        '
        band.Columns("smnm").Header.VisiblePosition = 0
        band.Columns("cnt_n").Header.VisiblePosition = 1
        band.Columns("totfrgross_n").Header.VisiblePosition = 2
        band.Columns("avgfrgross_n").Header.VisiblePosition = 3
        band.Columns("cnt_u").Header.VisiblePosition = 4
        band.Columns("totfrgross_u").Header.VisiblePosition = 5
        band.Columns("avgfrgross_u").Header.VisiblePosition = 6

    End Sub


    Private Sub GridConfigure(ByVal e As Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs)

        e.Layout.Bands(0).Override.AllowRowFiltering = DefaultableBoolean.False
        e.Layout.Bands(0).Override.RowFilterMode = RowFilterMode.AllRowsInBand
        e.Layout.Bands(0).UseRowLayout = True
        e.Layout.Bands(0).GroupHeadersVisible = True

        e.Layout.AutoFitStyle = AutoFitStyle.ResizeAllColumns
        e.Layout.BorderStyle = UIElementBorderStyle.Solid
        e.Layout.GroupByBox.Hidden = True
        e.Layout.MaxColScrollRegions = 1
        e.Layout.MaxRowScrollRegions = 1
        e.Layout.Appearance.FontData.Name = "Arial"
        e.Layout.Appearance.FontData.SizeInPoints = 9
        e.Layout.Scrollbars = Scrollbars.Vertical
        e.Layout.ScrollBounds = ScrollBounds.ScrollToFill
        e.Layout.ScrollStyle = ScrollStyle.Immediate

        e.Layout.Override.AllowColMoving = AllowColMoving.NotAllowed
        e.Layout.Override.AllowColSizing = AllowColSizing.None
        e.Layout.Override.AllowColSwapping = AllowColSwapping.NotAllowed
        e.Layout.Override.CellClickAction = CellClickAction.EditAndSelectText
        e.Layout.Override.HeaderClickAction = HeaderClickAction.SortMulti
        e.Layout.Override.RowSelectors = DefaultableBoolean.False
        e.Layout.Override.RowSizing = RowSizing.AutoFixed
        e.Layout.Override.SelectTypeCell = SelectType.None
        e.Layout.Override.SelectTypeCol = SelectType.None
        e.Layout.Override.SelectTypeRow = SelectType.None
        e.Layout.Override.ActiveRowAppearance.BackColor = Color.FromArgb(255, 255, 192)
        e.Layout.Override.CellPadding = 3
        e.Layout.Override.SummaryDisplayArea = SummaryDisplayAreas.BottomFixed

    End Sub

End Class
