Public Class UltraGridSummaryAverage
    Implements Infragistics.Win.UltraWinGrid.ICustomSummaryCalculator

    Public Enum _CALCTYPE
        FRONTGROSS_N
        BACKGROSS_N
        FRONTGROSS_U
        BACKGROSS_U
    End Enum

    Private mCnt As Integer
    Private mTot As Double
    Public CALCTYPE As _CALCTYPE = _CALCTYPE.FRONTGROSS_N

    Public Sub New(ByVal value As _CALCTYPE)
        Me.CALCTYPE = value
    End Sub

    Public Sub BeginCustomSummary(ByVal summarySettings As Infragistics.Win.UltraWinGrid.SummarySettings, ByVal rows As Infragistics.Win.UltraWinGrid.RowsCollection) Implements Infragistics.Win.UltraWinGrid.ICustomSummaryCalculator.BeginCustomSummary
        mCnt = 0
        mTot = 0
    End Sub

    Public Sub AggregateCustomSummary(ByVal summarySettings As Infragistics.Win.UltraWinGrid.SummarySettings, ByVal row As Infragistics.Win.UltraWinGrid.UltraGridRow) Implements Infragistics.Win.UltraWinGrid.ICustomSummaryCalculator.AggregateCustomSummary
        Select Case Me.CALCTYPE
            Case _CALCTYPE.FRONTGROSS_N
                mCnt += row.Cells("cnt_n").Value
                mTot += row.Cells("totfrgross_n").Value

            Case _CALCTYPE.FRONTGROSS_U
                mCnt += row.Cells("cnt_u").Value
                mTot += row.Cells("totfrgross_u").Value

            Case _CALCTYPE.BACKGROSS_N
                mCnt += row.Cells("cnt_n").Value
                mTot += row.Cells("totbkgross_n").Value

            Case _CALCTYPE.BACKGROSS_U
                mCnt += row.Cells("cnt_u").Value
                mTot += row.Cells("totbkgross_u").Value

        End Select
    End Sub

    Public Function EndCustomSummary(ByVal summarySettings As Infragistics.Win.UltraWinGrid.SummarySettings, ByVal rows As Infragistics.Win.UltraWinGrid.RowsCollection) As Object Implements Infragistics.Win.UltraWinGrid.ICustomSummaryCalculator.EndCustomSummary
        If mCnt < 1 Then Return 0
        Return Math.Round(mTot / mCnt, 4)
    End Function

End Class

